[PATCH] Support for NO_OPENSSL
[git/dscho.git] / t / test-lib.sh
blobf97f8eb395299f17873f6e6587db235e583cb45e
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
6 # For repeatability, reset the environment to known value.
7 LANG=C
8 TZ=UTC
9 export LANG TZ
10 unset AUTHOR_DATE
11 unset AUTHOR_EMAIL
12 unset AUTHOR_NAME
13 unset COMMIT_AUTHOR_EMAIL
14 unset COMMIT_AUTHOR_NAME
15 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
16 unset GIT_AUTHOR_DATE
17 unset GIT_AUTHOR_EMAIL
18 unset GIT_AUTHOR_NAME
19 unset GIT_COMMITTER_EMAIL
20 unset GIT_COMMITTER_NAME
21 unset GIT_DIFF_OPTS
22 unset GIT_DIR
23 unset GIT_EXTERNAL_DIFF
24 unset GIT_INDEX_FILE
25 unset GIT_OBJECT_DIRECTORY
26 unset SHA1_FILE_DIRECTORIES
27 unset SHA1_FILE_DIRECTORY
29 # Each test should start with something like this, after copyright notices:
31 # test_description='Description of this test...
32 # This test checks if command xyzzy does the right thing...
33 # '
34 # . ./test-lib.sh
36 error () {
37 echo "* error: $*"
38 exit 1
41 say () {
42 echo "* $*"
45 test "${test_description}" != "" ||
46 error "Test script did not set test_description."
48 while test "$#" -ne 0
50 case "$1" in
51 -d|--d|--de|--deb|--debu|--debug)
52 debug=t; shift ;;
53 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
54 immediate=t; shift ;;
55 -h|--h|--he|--hel|--help)
56 echo "$test_description"
57 exit 0 ;;
58 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
59 verbose=t; shift ;;
61 break ;;
62 esac
63 done
65 if test "$verbose" = "t"
66 then
67 exec 4>&2 3>&1
68 else
69 exec 4>/dev/null 3>/dev/null
72 test_failure=0
73 test_count=0
76 # You are not expected to call test_ok_ and test_failure_ directly, use
77 # the text_expect_* functions instead.
79 test_ok_ () {
80 test_count=$(expr "$test_count" + 1)
81 say " ok $test_count: $@"
84 test_failure_ () {
85 test_count=$(expr "$test_count" + 1)
86 test_failure=$(expr "$test_failure" + 1);
87 say "FAIL $test_count: $1"
88 shift
89 echo "$@" | sed -e 's/^/ /'
90 test "$immediate" == "" || exit 1
94 test_debug () {
95 test "$debug" == "" || eval "$1"
98 test_expect_failure () {
99 test "$#" == 2 ||
100 error "bug in the test script: not 2 parameters to test-expect-failure"
101 say >&3 "expecting failure: $2"
102 if eval >&3 2>&4 "$2"
103 then
104 test_failure_ "$@"
105 else
106 test_ok_ "$1"
110 test_expect_success () {
111 test "$#" == 2 ||
112 error "bug in the test script: not 2 parameters to test-expect-success"
113 say >&3 "expecting success: $2"
114 if eval >&3 2>&4 "$2"
115 then
116 test_ok_ "$1"
117 else
118 test_failure_ "$@"
122 test_done () {
123 case "$test_failure" in
125 # We could:
126 # cd .. && rm -fr trash
127 # but that means we forbid any tests that use their own
128 # subdirectory from calling test_done without coming back
129 # to where they started from.
130 # The Makefile provided will clean this test area so
131 # we will leave things as they are.
133 say "passed all $test_count test(s)"
134 exit 0 ;;
137 say "failed $test_failure among $test_count test(s)"
138 exit 1 ;;
140 esac
143 # Test the binaries we have just built. The tests are kept in
144 # t/ subdirectory and are run in trash subdirectory.
145 PATH=$(pwd)/..:$PATH
147 # Test repository
148 test=trash
149 rm -fr "$test"
150 mkdir "$test"
151 cd "$test"
152 git-init-db 2>/dev/null || error "cannot run git-init-db"